/*******************
Ad Format: Scroll Reveal
Amazon Template Version: 1.0.1
Last Updated On: 2023-02-20
*******************/

var creativeVersion = "1.0.0"; 
var lastModified = "2021-08-31";
var templateVersion = "1.0.0";
var adId, rnd, uid;
var sdkData;

var isLandscape;
var viewportWidth;
var viewportHeight;
var adWidth;
var adHeight;
var adTopPercentage;
var adBottomPercentage;
var adVisiblePercentage;
var sizeCheckerTimer;

var adContainer;
var videoContainer;
var video;
var clickthroughButtonContainer;
var logo;
var title;
var cta_btn;
var user_action_btn;
var snap_to_fs_btn;
var exit_fs_btn;
var overlay_hotspot;

function initializeCreative() {
	EBG.pm.bind("sendCreativeId", function () {
		eventManager.apply(this, arguments);
	}, this);
	EBG.pm.bind("eventCallback", function () {
		eventManager.apply(this, arguments);
	}, this);

	typeof Modernizr == "object" && (Modernizr.touch = Modernizr.touch || "ontouchstart" in window);

	initializeGlobalVariables();
	addEventListeners();

	initializeVideo();	
}

function initializeGlobalVariables() {
	adId = EB._adConfig.adId;
	rnd = EB._adConfig.rnd;
	uid = EB._adConfig.uid;

	adContainer = document.getElementById("container");
	video = document.getElementById("video");
	clickthroughButtonContainer = document.getElementById("button-container");
	clickthroughButton = document.querySelector(".cta_btn");
	overlay_hotspot = document.getElementById("overlay_hotspot");
	
	logo = new Widget({
		name: "logo",
		bottom: "10px",
		right: "10px",
		width: "144px",
		height: "21px",
		asset: "panels/expand/images/logo_white.png" 
	});

	title = new Widget({
		name: "title",
		top: "15px",
		left: "10px",
		width: "140px",
		height: "21px",
		html: '<span style="color:#FFF; font-weight:bold; font-size:20px; font-family: Arial">Scroll Reveal</span>', // asset from workspace root, will treat as widget background
		callback: "handleTitleButtonClick",
		inapp: false
	});

	cta_btn = new Widget({
		name: "cta_btn",
		top: "30px",
		left: "10px",
		width: "100px",
		height: "30px",
		html: '<button id="cta_btn" style="cursor:pointer; color: #111111; border-radius:3px !important; border: #c19b3b solid 1px !important; min-width: 100px; height: 100%; background: #f9ce6d;background: -moz-linear-gradient(top,  #f9ce6d 0%, #f6bd41 100%);background: -webkit-linear-gradient(top,  #f9ce6d 0%,#f6bd41 100%);background: linear-gradient(to bottom,  #f9ce6d 0%,#f6bd41 100%);filter: progid:DXImageTransform.Microsoft.gradient( startColorstr="#f9ce6d", endColorstr="#f6bd41",GradientType=0 );  user-select: none; outline: none; cursor: pointer;">Clickthrough</button>',
		callback: "handleClickthroughButtonClick",
		inapp: false
	});
	
	user_action_btn = new Widget({
		name: "user_action_btn",
		top: "30px",
		left: "120px",
		width: "100px",
		height: "30px",
		html: '<button id="user_action_btn" style="cursor:pointer; color: #111111; border-radius:3px !important; border: #c19b3b solid 1px !important; min-width: 100px; height: 100%; background: #f9ce6d;background: -moz-linear-gradient(top,  #f9ce6d 0%, #f6bd41 100%);background: -webkit-linear-gradient(top,  #f9ce6d 0%,#f6bd41 100%);background: linear-gradient(to bottom,  #f9ce6d 0%,#f6bd41 100%);filter: progid:DXImageTransform.Microsoft.gradient( startColorstr="#f9ce6d", endColorstr="#f6bd41",GradientType=0 );  user-select: none; outline: none; cursor: pointer;">User Action</button>',
		callback: "handleClickUserActionClick",
		inapp: false
	});
	
	snap_to_fs_btn = new Widget({
		name: "snap_to_fs",
		top: "30px",
		right: "10px",
		width: "100px",
		height: "30px",
		html: '<button id="snap_to_fs_btn" style="cursor:pointer; color: #111111; border-radius:3px !important; border: #c19b3b solid 1px !important; min-width: 100px; height: 100%; background: #f9ce6d;background: -moz-linear-gradient(top,  #f9ce6d 0%, #f6bd41 100%);background: -webkit-linear-gradient(top,  #f9ce6d 0%,#f6bd41 100%);background: linear-gradient(to bottom,  #f9ce6d 0%,#f6bd41 100%);filter: progid:DXImageTransform.Microsoft.gradient( startColorstr="#f9ce6d", endColorstr="#f6bd41",GradientType=0 );  user-select: none; outline: none; cursor: pointer;">Expand</button>',
		callback: "snapToFullscreenMode",
		inapp: false
	});


	exit_fs_btn = new Widget({
		name: "exit_fs",
		top: "30px",
		right: "10px",
		width: "100px",
		height: "30px",
		html: '<button id="exit_fs_btn" style="cursor:pointer; color: #111111; border-radius:3px !important; border: #c19b3b solid 1px !important; min-width: 100px; height: 100%; background: #f9ce6d;background: -moz-linear-gradient(top,  #f9ce6d 0%, #f6bd41 100%);background: -webkit-linear-gradient(top,  #f9ce6d 0%,#f6bd41 100%);background: linear-gradient(to bottom,  #f9ce6d 0%,#f6bd41 100%);filter: progid:DXImageTransform.Microsoft.gradient( startColorstr="#f9ce6d", endColorstr="#f6bd41",GradientType=0 );  user-select: none; outline: none; cursor: pointer;">Collapse</button>',
		callback: "exitFullscreenMode",
		css: "display: none;",
		inapp: false
	});
	
	
	panelLoaded();
	positionAdElements();
	setTimeout(createTextBar, 1500); 
}

function initializeVideo() {
	var videoTrackingModule = new EBG.VideoModule(video);
}

function addEventListeners() {
	clickthroughButton.addEventListener("click", handleClickthroughButtonClick);
	overlay_hotspot.addEventListener("click", handleOverlayHotSpotClick);
	
	if (video && EB.API.browser.webkit) {
		if (EB.API.os.ios && EB.API.os.verN >= 9.3) {
			video.addEventListener("webkitbeginfullscreen", handleBeginFullScreen, false);
			video.addEventListener("webkitendfullscreen", handleEndFullScreen, false);
		}
		else {
			video.addEventListener("webkitfullscreenchange", handleFullScreenChange, false);
		}
	}

	window.addEventListener("resize", handleResize, false);
	window.addEventListener("message", onMessageReceived, false);
	if (EB.API.os.mobile || isTouchSupported()) {
		window.addEventListener(window.navigator.msPointerEnabled ? "MSPointerDown" : "touchstart", handleTouchStart, false);
		window.addEventListener(window.navigator.msPointerEnabled ? "MSPointerUp" : "touchend", handleTouchEnd, false);
	}
	window.addEventListener("mouseup", handleTouchEnd, false);
	document.addEventListener("wheel", handleWheelScroll, false);
	document.addEventListener("keydown", handleKeyDown, false);
	document.addEventListener("touchmove", handleKeyDown, false);
}


function handleClickthroughButtonClick() {
	stopVideo(); 
	EB.clickthrough();
	exitFullscreenMode();
}

function handleTitleButtonClick() {
	stopVideo(); 
	EB.clickthrough();
}

function handleClickUserActionClick() {
	stopVideo(); 
	EB.userActionCounter("user_action_btn"); 
}

function handleOverlayHotSpotClick() {
	stopVideo(); 
	EB.clickthrough();
}

function handleResize() {
	if (typeof positionAdElements === "function") {
		positionAdElements();
	}
}

function handleBeginFullScreen() {
	sendMessage("creativeEnterFullScreen", {});
}

function handleEndFullScreen() {	
	sendMessage("creativeExitFullScreen", {});
}

function handleFullScreenChange() {
	if (document.webkitIsFullScreen) {
		handleBeginFullScreen();
	}
	else {
		handleEndFullScreen();
	}
}

function handleKeyDown() {
	handleWheelScroll();
}

function handleWheelScroll() {
	sendMessage("creativeWheelScroll", {});
}

function handleTouchStart(e) {
	if (typeof e !== "undefined" && isTouchEvent(e)) {
		sendMessage("creativeTouchStart", getTouchPosition(e));
	}
}

function handleTouchEnd(e) {
	if (typeof e !== "undefined" && isTouchEvent(e)) {
		sendMessage("creativeTouchEnd", getTouchPosition(e));
	}
}


function stopVideo(rewind) {
	if (video) {
		document.body.focus();
		video.pause();
		if (rewind) {
			video.currentTime = 0;
		}
	}
}

var checkClose = false;
function snapToFullscreenMode() {
	if(checkClose==true){
        checkClose = false;
    }
    
	sendMessage("snapToFullscreenMode", {});
	snap_to_fs_btn.hide();
	setTimeout(function() {
		exit_fs_btn.show();
	}, 50);	
	EB.userActionCounter("snapToFS");	
}

function exitFullscreenMode() {
	if(checkClose==false){
        EB.userActionCounter("exitFS");
        checkClose = true;
    }
    
	sendMessage("exitFullscreenMode", {});
	exit_fs_btn.hide();
	cta_btn.show();
	EB.API.setStyle(clickthroughButtonContainer, {
		display: "none"
	});
	setTimeout(function() {
		snap_to_fs_btn.show();
	}, 50);	
}

function adScrollIn() {
}

function adScrollAway() {
	stopVideo();
}

function adSnapIn() {
}

function adSnapOut() {
	stopVideo();
}

function adCollapsed() {
	stopVideo();
}

function onPageScroll(data) {
	viewportWidth = data.viewPortMetrics.width;
	viewportHeight = data.viewPortMetrics.height;
	adWidth = data.adMetrics.width;
	adHeight = data.adMetrics.height;
	adTopPercentage = data.adMetrics.topPercentage;
	adBottomPercentage = data.adMetrics.bottomPercentage;
	adVisiblePercentage = data.adMetrics.visiblePercentage;
	isLandscape = viewportWidth > viewportHeight;
	positionAdElements();
}

function positionAdElements() {
	if (EB.API.getCustomVar("mdChangeImageOnOrientation")) {
		EB.API.setStyle(document.body, {
			backgroundImage: "url(images/background_" + (isLandscape ? "landscape" : "portrait") + ".jpg)"
		});
	}
	
	if (EB.API.os.android) {
		if (sizeCheckerTimer) {
			clearTimeout(sizeCheckerTimer);
		}
		sizeCheckerTimer = setTimeout(function () {
			if (parseInt(document.body.style.width) !== window.innerWidth || parseInt(document.body.style.height) !== window.innerHeight) {
				positionAdElements();
			}
		}, 500);
	}
}

function panelLoaded() {
	sendMessage("panelIsLoaded", {});
}

function isTouchSupported() {
	var msTouchEnabled = window.navigator.msMaxTouchPoints;
	var generalTouchEnabled = "ontouchstart" in document.createElement("div");

	if (msTouchEnabled || generalTouchEnabled) {
		return true;
	}
	return false;
}

function isTouchEvent(e) {
	var isTouchEvent = false;
	if (e.hasOwnProperty("pointerType")) {
		if (e.pointertype.indexOf("touch") !== -1) {
			isTouchEvent = true;
		}
	}
	else if (e.hasOwnProperty("type")) {
		if (e.type.indexOf("touch") !== -1) {
			isTouchEvent = true;
		}
	}
	return isTouchEvent;
}

function getTouchPosition(e) {
	if (window.navigator.msPointerEnabled) {
		return {
			x: e.pageX || e.targetTouches[0].pageX,
			y: e.pageY || e.targetTouches[0].pageY
		};
	}
	else {
		return {
			x: e.changedTouches[0].pageX,
			y: e.changedTouches[0].pageY
		};
	}
}

function getTopBarHeight() {
	return EB.API.getCustomVar("mdDisplayTopBar") ? EB.API.getCustomVar("mdTopBarHeight") : 0;
}

function getBottomBarHeight() {
	return EB.API.getCustomVar("mdDisplayBottomBar") ? EB.API.getCustomVar("mdBottomBarHeight") : 0;
}

function getBooleanOption(options) {
	var opt = options.toString().split("");
	return {
		desktop: Boolean(opt[0] * 1),
		ios: Boolean(opt[1] * 1),
		android: Boolean(opt[2] * 1),
		windowsphone: Boolean(opt[3] * 1)
	};
}

function resizeTextBar() {
	var textBars = document.getElementsByClassName("text-bar-div");
	for (var i = 0; i < textBars.length; i++) {
		EB.API.setStyle(textBars[i], {
			width: EBG.px(window.innerWidth)
		});
	}
}

function createTextBar() {
	if (parseInt(EB.API.getCustomVar("mdTopBottomBarInCreative")) === 0) {
		return;
	}
	else {
		var barInCreativeEnabled = getBooleanOption(EB.API.getCustomVar("mdTopBottomBarInCreative"));
		if ((!EB.API.os.mobile && barInCreativeEnabled.desktop) ||
			(EB.API.os.ios && barInCreativeEnabled.ios) ||
			(EB.API.os.android && barInCreativeEnabled.android) ||
			(EB.API.os.windowsphone && barInCreativeEnabled.windowsphone)) {
		
			if (EB.API.getCustomVar("mdDisplayTopBar")) {
				if (document.getElementsByClassName("text-bar-div top").length > 0) {
					return;
				}
				var topBarDiv = document.createElement("div");
				document.body.appendChild(topBarDiv);
				topBarDiv.setAttribute("class", "text-bar-div top");
				topBarDiv.setAttribute("style", EB.API.getCustomVar("mdTopBarLabelStyle"));
				topBarDiv.innerHTML = EB.API.getCustomVar("mdTopBarLabel");
				EB.API.setStyle(topBarDiv, {
					position: "absolute",
					top: "0px",
					left: "0px",
					width: EBG.px(window.innerWidth),
					height: EBG.px(EB.API.getCustomVar("mdTopBarHeight")),
					backgroundColor: EB.API.getCustomVar("mdTopBarColor"),
					lineHeight: EBG.px(EB.API.getCustomVar("mdTopBarHeight")),
					zIndex: EB.API.getStyle(adContainer, "zIndex") + 1
				});
			}
			if (EB.API.getCustomVar("mdDisplayBottomBar")) {
				if (document.getElementsByClassName("text-bar-div bottom").length > 0) {
					return;
				}
				var bottomBarDiv = document.createElement("div");
				document.body.appendChild(bottomBarDiv);
				bottomBarDiv.setAttribute("class", "text-bar-div bottom");
				bottomBarDiv.setAttribute("style", EB.API.getCustomVar("mdBottomBarLabelStyle"));
				bottomBarDiv.innerHTML = EB.API.getCustomVar("mdBottomBarLabel");
				EB.API.setStyle(bottomBarDiv, {
					position: "absolute",
					bottom: "0px",
					left: "0px",
					width: EBG.px(window.innerWidth),
					height: EBG.px(EB.API.getCustomVar("mdBottomBarHeight")),
					backgroundColor: EB.API.getCustomVar("mdBottomBarColor"),
					lineHeight: EBG.px(EB.API.getCustomVar("mdBottomBarHeight")),
					zIndex: EB.API.getStyle(adContainer, "zIndex") + 1
				});
			}
			window.addEventListener("resize", resizeTextBar, false);
		}
	}
}

function Widget(widget) {
	this.widgetData = widget;
	sendMessage("addWidget", {
		widget: widget
	});
}

Widget.prototype = {
	show: function () {
		sendMessage("widgetHandler", {
			action: "show",
			widgetData: this.widgetData
		});
	},
	hide: function () {
		sendMessage("widgetHandler", {
			action: "hide",
			widgetData: this.widgetData
		});
	},
	remove: function () {
		sendMessage("widgetHandler", {
			action: "remove",
			widgetData: this.widgetData
		});
	},	
	resizeTo: function (size) {
		var widgetData = this.widgetData;
		widgetData.size = size;		
		sendMessage("widgetHandler", {
			action: "resizeTo",
			widgetData: widgetData
		});
	},
	moveTo: function (loc) {
		var widgetData = this.widgetData;
		widgetData.loc = loc;
		sendMessage("widgetHandler", {
			action: "moveTo",
			widgetData: widgetData
		});
	}
};

function onMessageReceived(event) {
	try {
		var data = JSON.parse(event.data);
		if (typeof window[data.type] === "function") {
			window[data.type](data.data);
		}
	}
	catch (error) {}
}


var listenerQueue;
var creativeIFrameId;

function sendMessage(type, data) {


	if (!data.type) data.type = type;
	EB._sendMessage(type, data);
}

function addCustomScriptEventListener(eventName, callback, interAd) {
	listenerQueue = listenerQueue || {};
	var data = {
		uid: uid,
		listenerId: Math.ceil(Math.random() * 1000000000),
		eventName: eventName,
		interAd: !!(interAd),
		creativeIFrameId: creativeIFrameId
	};
	sendMessage("addCustomScriptEventListener", data);
	data.callback = callback;
	listenerQueue[data.listenerId] = data;
	return data.listenerId;
}

function dispatchCustomScriptEvent(eventName, params) {
	params = params || {};
	params.uid = uid;
	params.eventName = eventName;
	params.creativeIFrameId = creativeIFrameId;
	sendMessage("dispatchCustomScriptEvent", params);
}

function removeCustomScriptEventListener(listenerId) {
	var params = {
		uid: uid,
		listenerId: listenerId,
		creativeIFrameId: creativeIFrameId
	};

	sendMessage("removeCustomScriptEventListener", params);
	if (listenerQueue[listenerId])
		delete listenerQueue[listenerId];
}

function eventManager(event) {

	var msg;
	if (typeof event == "object" && event.data) {
		msg = JSON.parse(event.data);

	}
	else {
		msg = {
			type: event.type,
			data: event
		};
	}
	if (msg.type && msg.data && (!uid || (msg.data.uid && msg.data.uid == uid))) {
		switch (msg.type) {
		case "sendCreativeId":
			creativeIFrameId = msg.data.creativeIFrameId;
			addCustomScriptEventListener('pageScroll', onPageScroll);
			sendMessage("dispatchScrollPos", {
				uid: uid
			});
			if (creativeContainerReady)
				creativeContainerReady();
			break;
		case "eventCallback":
			var list = msg.data.listenerIds;
			var length = list.length;
			for (var i = 0; i < length; i++) {
				try {
					var t = listenerQueue[list[i]];
					if (!t) continue;
					t.callback(msg.data);
				}
				catch (e) {}
			}
			break;
		}
	}
}

window.addEventListener("message", function () {
	try {
		eventManager.apply(this, arguments);
	}
	catch (e) {}
}, false);



adkit.onReady(initializeCreative);